/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$XConsortium: AllocWidInfo.c /main/7 1995/07/14 11:24:11 drk $"
#endif
#endif
/***********************************************************************
  	@(#)AllocWidInfo.c	1.7.1.1	Date:1/22/91
  	Author: TAT
	History:
            05/18/90 SJS add to SCCS
            06/21/90 SJS add being_destroyed & convenience parent
	Calls:

	Summary:
            Allocates a widget info record and connects the pointers in the
            widget info hierarchy appropriately. This function does not
            perform color resource set up. (See mvsSetupWidgetInfo() )

            INPUTS
                widget_class_info  - Pointer to the mvs widget class info
                                     record that
                                     you want this widget info record to point
                                     to

                parent_widget_info - Pointer to the parent widget info record

                widget             - The Xt widget id
  
            OUTPUTS
                none

            RETURNS
                Pointer to newly alloc'ed widget info record.
************************************************************************/

#include <AutoMessages.h>
#include "mvslib.h"

MvsWidgetInfoRecord *mvsAllocWidgetInfo(wc_info, pinfo, widget)
MvsWidgetClassInfo *wc_info;
MvsWidgetInfoRecord *pinfo;
Widget widget;
{
    int i,j;
    MvsWidgetInfoRecord *winfo;

    for (i=1; i<=mvsNumWidgetInfos; i++) {
        if (i >= MAX_NUM_WIDGET_INFOS) {
            AutoMessage(_AutoMessages[WARNMSG120]);
            exit(-1);
        }

        if (!mvsWidgetInfos[i].in_use) {
            mvsWidgetInfos[i].in_use = 1;
            mvsWidgetInfos[i].being_destroyed = False;
            mvsWidgetInfos[i].c_parent = False;

            if (i == mvsNumWidgetInfos)
                mvsNumWidgetInfos++;

            mvsWidgetInfos[i].parent = pinfo;
            if (pinfo != NULL) {
                winfo = mvsWidgetInfos[i].parent->first_child;
                if (winfo == NULL)
                    mvsWidgetInfos[i].parent->first_child = &mvsWidgetInfos[i];
                else {
                    while (winfo->next_sibling != NULL)
                        winfo = winfo->next_sibling;
                    winfo->next_sibling = &mvsWidgetInfos[i];
                }
	    }

            mvsWidgetInfos[i].widget = widget;
            mvsWidgetInfos[i].widget_class_info = wc_info;
            mvsWidgetInfos[i].callbacks_setup = 0;
            mvsWidgetInfos[i].first_child = NULL;
            mvsWidgetInfos[i].next_sibling = NULL;


            if (wc_info != NULL) {
                for (j=0; j<wc_info->num_res_colors; j++) {
                    mvsWidgetInfos[i].unique_color_ref[j] 
                        	= mvsAllocUniqueColor(&mvsWidgetInfos[i],j);
/* Automation Added */
		    mvsWidgetInfos[i].widgetUniqueColorInfo[j].in_use 
				= True;
		    mvsWidgetInfos[i].widgetUniqueColorInfo[j].widget_info 
				= &mvsWidgetInfos[i];
		    mvsWidgetInfos[i].widgetUniqueColorInfo[j].color_ref 
				= j;
/* End Automation Added */
		}
            }

            break;
	}
    } /* End for(i<=mvsNumWidgetInfos) */

    return (&mvsWidgetInfos[i]);

} /* End mvsAllocWidgetInfo() */
