/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$XConsortium: GetObjName.c /main/7 1995/07/14 11:34:44 drk $"
#endif
#endif
/***********************************************************************
  	@(#)GetObjName.c	1.3.1.1	Date:1/22/91
  	Author: TAT
	History:
            05/24/90 SJS add to sccs
	Calls:

	Summary:
            Returns a pointer to a statically declared string naming the
        specified object.

        INPUTS:
            object     - object pointer
        
        OUTPUTS:
            none

        RETURNS:
            string object name
************************************************************************/
#include "xislib.h"

char *xisGetObjectName(object)
XisObjectRecord *object;
{
    static char name[255];
    static char other_string[] = "Other";
    static char root_string[] = "Root Window";
    static char sync_string[] = "Sync Window";
    static char empty_string[] = "Windowless,Widgetless";

    if (object == NULL)
        return other_string;

    if (object->id.widget != NULL) {
        sprintf(name,"%s #%d %s of class %s",
                    (*xisGetObjectTypeName)(object->id.object_type),
                    object->id.instance,
                    XtName(object->id.widget),
                    (*xisGetWidgetClassName)(object->id.widget));

        return name;
    }

    else {
        if (!object->id.window)
            return empty_string;

        else {
            if (object->id.window == xisRootWindow)
                return root_string;
            else if (object->id.window == xisSyncWindow)
                return sync_string;
            else
                return other_string;
        }
    }

} /* End xisGetObjectName() */
