/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$XConsortium: GetWindoName.c /main/7 1995/07/14 11:35:46 drk $"
#endif
#endif
/***********************************************************************
  	@(#)GetWindoName.c	1.3.1.2	Date:2/7/91
  	Author: TAT
	History:
            05/24/90 SJS add to sccs
	Calls:

	Summary:
            Returns a pointer to a statically declared string naming the
        specified window.

        INPUTS:
            window       - window id
        
        OUTPUTS:
            none

        RETURNS:
            string window name
************************************************************************/
#include "xislib.h"
#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <X11/Core.h>
#include <X11/CoreP.h>

char *xisGetWindowName(window)
Window window;
{
    char *name = NULL;
    Widget widg;
    static char other_string[] = "Other";
    CoreClassPart *class;

    widg = XtWindowToWidget(xisDisplay, window);

    while (widg != NULL && name == NULL) {
        if (window == XtWindow(widg)) {
            class = (CoreClassPart *)XtClass(widg);
            name = class->class_name;
	}
        widg = XtParent(widg);
    }

    if (name == NULL)
        return other_string;
    else
        return name;

} /* End xisGetWindowName() */
