/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$XConsortium: WindowExists.c /main/7 1995/07/14 11:37:16 drk $"
#endif
#endif
/***********************************************************************
  	@(#)WindowExists.c	1.4.1.1	Date:1/22/91
  	Author: TAT
	History:
            05/24/90 SJS add to sccs
	Calls:

	Summary:
            Determines if the specified window exists.

        INPUTS:
            window - window which may or may not exist
        
        OUTPUTS:
            none

        RETURNS:
            True if window exists
            False otherwise
************************************************************************/
#include "xislib.h"

static int weBadWindowFlag;

/**** ERROR HANDLER FOR WINDOW_EXISTS BELOW *****/

static int weErrorHandler(display_in,err_event)
Display *display_in;
XErrorEvent *err_event;
{
  if ((display_in == xisDisplay)&&(err_event->request_code == X_GetGeometry)&&
      ((err_event->error_code == BadDrawable)||(err_event->error_code == BadWindow)) )
      weBadWindowFlag = 1;
        
} /* End weErrorHandler() */

/**** WINDOW_EXISTS *****/

int xisWindowExists(window)
Window window;
{
    static char routine_name[] = "xisWindowExists";
    Window root_return;
    int x,y;
    unsigned int w,h,bw;
    unsigned int depth;

    xisUseSessionInfo(routine_name);

    weBadWindowFlag = 0;
    XSetErrorHandler(weErrorHandler);

    XGetGeometry(xisDisplay,window,&root_return,&x,&y,&w,&h,&bw,&depth);
    XSync(xisDisplay,False);

    XSetErrorHandler(NULL);

    return (!weBadWindowFlag);

} /* end xisWindowExists() */
