/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$XConsortium: MapWidget.c /main/7 1995/07/14 11:41:35 drk $"
#endif
#endif
/***********************************************************************
  	@(#)MapWidget.c	1.3.1.1	Date:1/22/91
  	Author: TAT
	History:
            06/21/90 TAT add to sccs
	Calls:

	Summary:
            Maps the widget by calling XtManageChild(). You should pass the
            child of the MenuShell or DialogShell to this routine.

        INPUTS:
            widget - the widget to map.
        
        OUTPUTS:
            none

        RETURNS:
            nothing
************************************************************************/

#include <AutoMessages.h>
#include "xislib.h"

void xisMapWidget(widget)
Widget widget;
{
    XisObjectRecord *object;
    XisObjectRecord *current_object;

    if (widget == NULL) 
        AutoMessage(_AutoMessages[WARNMSG16]);

    else {
        object = xisFindObjectFromWidget(widget);

        (*xisTraceMsg)("Got send_event_request = MapWidget for %s\n",
                       xisGetObjectName(object));
    
        /* Call all relavent InformExpectedActions functions */
  
        current_object = object;
    
        xisInform.is_valid = 1;
        xisInform.action_obj = current_object;
        xisInform.modifier_key_status = 0;
        xisInform.button_num = 0;
        xisInform.key_code = 0;
        xisInform.edge_code = 0;
        xisInform.num_clicks = 0;
        xisInform.event_code = EventMap;

        while (current_object != NULL) {

            if (current_object->proc_InformExpectedActions != NULL) {
                xisInform.current_obj = current_object;
                (*current_object->proc_InformExpectedActions)(EventMap); 
            }
            current_object = current_object->parent;
	}

        xisInform.is_valid = 0;

        XtManageChild(widget);

        xisProcessEvents(NULL,0);
    }
} /* End xisMapWidget() */
