/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$XConsortium: MovePntrRel.c /main/7 1995/07/14 11:41:49 drk $"
#endif
#endif
/***********************************************************************
  	@(#)MovePntrRel.c	1.5.1.1	Date:1/22/91
  	Author:
	History:
		07/18/90 PSN Fixed wrong call to non-existing procedure. Not
			     calls xisCMovePointer() correctly.
	Calls:

	Summary:
            Simulates a user moving the mouse some delta-x delta-y distance.

        INPUTS:
            delta_x - x coord of relative offset from current position
            delta_y - y coord of relative offset from current position
            direction - MoveAny, MoveUp, MoveDown, MoveLeft, MoveRight

        OUTPUTS:
            none

        RETURNS:
            nothing
************************************************************************/

#include <AutoMessages.h>
#include "xislib.h"

void xisMovePointerRelative(delta_x,delta_y)
int delta_x, delta_y;
{
    int curr_x,curr_y;
    XisObjectRecord *curr_object;
    XisObjectRecord *end_obj;
    Boolean valid = True;

    (*xisTraceMsg)("Got send_event_request = MovePointerRelative\n");


    /* Get current pointer location and current object over */

    xisGetPointerLocation(&curr_x,&curr_y);
    
    curr_object = xisFindObjectAtLocation(curr_x,curr_y);

/* Automation Added */

    end_obj = xisFindObjectAtLocation(curr_x + delta_x, curr_y + delta_y);

    if (end_obj == NULL) {
	AutoMessage(_AutoMessages[WARNMSG17]);
	valid = False;
    }
    /*
    else 
   	if (curr_object != end_obj)
	     AutoMessage(_AutoMessages[WARNMSG18]);
    */
	
    if (valid)
    	xisCMovePointer(curr_object, curr_x, curr_y,
			curr_x + delta_x, curr_y + delta_y);

/* End Automation Added */

} /* End xisMovePointerRelative() */
