/* $XConsortium: CxxPrim.cxx /main/4 1995/07/17 11:46:14 drk $ */
/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 */

extern "C" {
#include <testlib.h>
};
#include <sys/file.h>

/*  Standard C headers  */
#include <stdio.h>
#include <stdlib.h>

/* C++ headers */ 
#include <iostream.h>

/*  X headers  */
#include <X11/IntrinsicP.h>

/*  Xm headers  */
#include <Xm/Xm.h>
#include <Xm/MainW.h>
#include <Xm/Form.h>
#include <Xm/MessageB.h>
#include <Xm/Label.h>
#include <XmCxx/CxxXmString.h>
#include <ExmCxx/CxxSimple.h>

// These are used to indicate that the associated method has been
// invoked for coverage analysis.

unsigned char initializeCount = 0;
unsigned char resizeCount = 0;
unsigned char exposeCount = 0;
unsigned char set_valuesCount = 0;
unsigned char queryGeometryCount = 0;
unsigned char display_rectCount = 0;
unsigned char drawVisualCount = 0;
unsigned char draw_shadowCount = 0;
unsigned char create_gcCount = 0;
unsigned char destroy_gcCount = 0;
unsigned char select_gcCount = 0;
unsigned char calc_visual_sizeCount = 0;
unsigned char calc_widget_sizeCount = 0;
unsigned char SimpleActivateCount = 0;
unsigned char reconfigureCount = 0;

// This test doesn't do much.  A few resources a played with so that
// some of the XmCxxSimple class methods are excersized.

int main(int argc, char** argv)
{

  Widget	simpleWidget1;
  Arg		args[10];
  int		n;
  ExmCxxSimple	sw;

  CommonTestInit(argc, argv);

  simpleWidget1 = ExmCreateCxxSimple( Shell1, "MyCxxSimpleton", NULL, 0);
  XtManageChild(simpleWidget1);

  XtRealizeWidget(Shell1);

  CommonPause();

  n = 0;
  XtSetArg(args[n], XmNwidth, 200); n++;
  XtSetArg(args[n], XmNheight, 400); n++;

  XtSetValues(simpleWidget1, args, n);

  CommonPause();

  n = 0;
  XtSetArg(args[n], XmNshadowThickness, 20); n++;

  XtSetValues(simpleWidget1, args, n);

  CommonPause();

  n = 0;
  XtSetArg(args[n], XmNshadowThickness, 0); n++;

  XtSetValues(simpleWidget1, args, n);

  CommonPause();

  n = 0;
  XtSetArg(args[n], ExmNsimpleShape, ExmSHAPE_RECTANGLE); n++;

  XtSetValues(simpleWidget1, args, n);

  CommonPause();

  cout << "		COVERAGE REPORT\n"
       << "             ---------------\n"
       << "ExmCxxSimple::initialize "
       << (initializeCount ? "was" : "was not") << " invoked.\n"
       << "ExmCxxSimple::resize "
       << (resizeCount ? "was" : "was not") << " invoked.\n"
       << "ExmCxxSimple::expose "
       << (exposeCount ? "was" : "was not") << " invoked.\n"
       << "ExmCxxSimple::set_values "
       << (set_valuesCount ? "was" : "was not") << " invoked.\n"
       << "ExmCxxSimple::query_geometry "
       << (queryGeometryCount ? "was" : "was not") << " invoked.\n"
       << "ExmCxxSimple::widget_display_rect "
       << (display_rectCount ? "was" : "was not") << " invoked.\n"
       << "ExmCxxSimple::draw_visual "
       << (drawVisualCount ? "was" : "was not") << " invoked.\n"
       << "ExmCxxSimple::draw_shadow "
       << (draw_shadowCount ? "was" : "was not") << " invoked.\n"
       << "ExmCxxSimple::create_gc "
       << (create_gcCount ? "was" : "was not") << " invoked.\n"
       << "ExmCxxSimple::destroy_gc "
       << (destroy_gcCount ? "was" : "was not") << " invoked.\n"
       << "ExmCxxSimple::select_gc "
       << (select_gcCount ? "was" : "was not") << " invoked.\n"
       << "ExmCxxSimple::calc_visual_size "
       << (calc_visual_sizeCount ? "was" : "was not") << " invoked.\n"
       << "ExmCxxSimple::calc_widget_size "
       << (calc_widget_sizeCount ? "was" : "was not") << " invoked.\n"
       << "ExmCxxSimple::SimpleActivate "
       << (SimpleActivateCount ? "was" : "was not") << " invoked.\n"
       << "ExmCxxSimple::reconfigure "
       << (reconfigureCount ? "was" : "was not") << " invoked.\n" 
		<< flush ;

  CommonPause();

  XtAppMainLoop(app_context);
}
