/* $XConsortium: Navigation16.c /main/5 1995/07/15 21:11:54 drk $ */
/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 */

#include <testlib.h>
#include <Xm/XmP.h>

typedef struct wstruct
{
    Widget w;
    Widget (*createFunc)(Widget, String, ArgList, Cardinal);
    char* name;
} WStruct;

#define NUM_GADGETS 5

static Widget rowcol1;

static WStruct Widgets[NUM_GADGETS] =
{
    {NULL, XmCreateLabelGadget, "labelG1"},
    {NULL, XmCreateSeparatorGadget, "separatorG1"},
    {NULL, XmCreatePushButtonGadget, "pushBG1"},
    {NULL, XmCreateToggleButtonGadget, "toggleBG1"},
    {NULL, XmCreateArrowButtonGadget, "arrowBG1"}
};

void printWidgetName(Widget w)
{
    int i;
    char* name;

    name = "Unknown widget";
    if (w == rowcol1)
       name = "rowcol1";
    else if (w == Shell1)
	name = "Shell1";
    else
	for (i = 0; i < NUM_GADGETS; i++)
	    if (w == Widgets[i].w)
		{
		    name = Widgets[i].name;
		    break;
		}
    printf("%s", name);
}

void focusCB(Widget w, XtPointer client_data, XtPointer call_data )
{
    XmFocusMovedCallbackStruct* cbs;

    cbs = (XmFocusMovedCallbackStruct*)call_data;

    printf("Focus moved from ");

    printWidgetName(cbs->old_focus);

    printf(" to ");

    printWidgetName(cbs->new_focus);

    printf("\n");
}

main (int argc, char ** argv)
{
   Arg args[10];
   int i;

   /* initialize Toolkit */
   CommonTestInit(argc, argv);

   rowcol1 = XmCreateRowColumn(Shell1, "rowcol1", args, 0);

   for (i = 0; i < NUM_GADGETS; i++) {
       Widgets[i].w
	   = Widgets[i].createFunc(rowcol1, Widgets[i].name, args, 0);
       XtManageChild(Widgets[i].w);
   }
   XtManageChild(rowcol1);

   XtRealizeWidget(Shell1);

   CommonPause();

   XmeAddFocusChangeCallback(Shell1, focusCB, NULL);

   CommonPause();

   XtAppMainLoop(app_context);
}
