/* $XConsortium: PIVMwm.c /main/5 1995/07/15 21:14:01 drk $ */
/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 */
#include <testlib.h>


/* initialize globals */

Atom            WM_S0;
Atom		WM_PAN;
Atom		WM_GOTO;
Atom            target;
int             send_size;
Widget          TestShell1;
Widget          X_Scale;
Widget          Y_Scale;
Widget          DrawingArea;



void InitializeAtoms();
void CreateControlPanel();
void DoneProc(Widget,XtPointer client_data, XtPointer call_data);
void DestinationProc(Widget,XtPointer client_data, XtPointer call_data);
void SendPanMsg(Widget,XtPointer,XtPointer);
void SendGotoMsg(Widget,XtPointer,XtPointer);
static XtPointer PackCARD32 (XtPointer, CARD32);
static XtPointer PackCARD16 (XtPointer, CARD16);
static XtPointer PackCARD8 (XtPointer, CARD8);



void
main (int argc, char** argv)
{

  Arg args[10];
  int n;

  

  CommonTestInit (argc,argv);
  CreateControlPanel();
  InitializeAtoms();

  /* Create UTM savvy DrawingArea */

  n=0;
  DrawingArea = XmCreateDrawingArea (Shell1, "DrawingArea", args, n);
  XtManageChild (DrawingArea);
  XtAddCallback (DrawingArea, XmNdestinationCallback, DestinationProc, (XtPointer)NULL);

  /* Create popup shell that user will get info on */

  
  n=0;
  XtSetArg (args[n], XmNheight, 200); n++;
  XtSetArg (args[n], XmNwidth, 200); n++;
  XtSetArg (args[n], XmNbackground, CommonGetColor ("forestgreen")); n++;
  TestShell1 = XtCreatePopupShell ("TestShell1", topLevelShellWidgetClass,
				   Shell1, args, n);
  XtManageChild (TestShell1);
  XtPopup (TestShell1, XtGrabNone);
  XtRealizeWidget (Shell1);

  CommonPause();
  CommonPause();
  CommonPause();
  CommonPause();

  XtAppMainLoop (app_context);

}


void 
InitializeAtoms()
{
  WM_S0     = XmInternAtom(display,"WM_S0",False);
  WM_PAN     = XmInternAtom(display,"_MOTIF_WM_PAN", False);
  WM_GOTO    = XmInternAtom(display,"_MOTIF_WM_GOTO", False);
}


void 
CreateControlPanel()
{
  Widget MainBBDialog1, MainRC1, MainForm1, MainForm2, Sep1;
  Widget PB1,PB2;

  Arg args[10];
  int n;
  XmString LabelString;

  n=0;
  MainBBDialog1 = XmCreateBulletinBoard (Shell1, "MainBBDialog1", args, n);
  XtManageChild (MainBBDialog1);
  
  n=0;
  MainRC1 = XmCreateRowColumn (MainBBDialog1, "MainRC1",args,n);
  XtManageChild (MainRC1);

  n=0;
  MainForm1 = XmCreateForm (MainRC1, "MainForm1", args, n);
  XtManageChild (MainForm1);

  n=0;
  Sep1 = XmCreateSeparator (MainRC1, "Spe1", args, n);
  XtManageChild (Sep1);

  n=0;
  MainForm2 = XmCreateForm (MainRC1, "MainForm2", args, n);
  XtManageChild (MainForm2);


  n=0;
  XtSetArg (args[n], XmNleftAttachment, XmATTACH_FORM); n++;
  PB1 = XmCreatePushButton (MainForm1, "Send pan message", args,n);
  XtManageChild (PB1);
  XtAddCallback (PB1, XmNactivateCallback, SendPanMsg, (XtPointer)NULL);


  n=0;
  XtSetArg (args[n], XmNrightAttachment, XmATTACH_FORM); n++;
  XtSetArg (args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
  XtSetArg (args[n], XmNleftWidget, PB1); n++;
  PB2 = XmCreatePushButton (MainForm1, "Send goto message", args,n);
  XtManageChild (PB2);
  XtAddCallback (PB2, XmNactivateCallback, SendGotoMsg, (XtPointer)NULL);

  LabelString = XmStringCreate ("x value", XmFONTLIST_DEFAULT_TAG);

  n=0;
  XtSetArg (args[n], XmNleftAttachment, XmATTACH_FORM); n++;
  XtSetArg (args[n], XmNorientation, XmHORIZONTAL); n++;
  XtSetArg (args[n], XmNtitleString,LabelString); n++;
  XtSetArg (args[n], XmNscaleMultiple,10); n++;
  XtSetArg (args[n], XmNshowValue,True); n++;
  XtSetArg (args[n], XmNminimum, -200); n++;
  XtSetArg (args[n], XmNmaximum, 200); n++;
  X_Scale = XmCreateScale (MainForm2, "X_Scale", args, n);
  XtManageChild (X_Scale);
  
  XmStringFree (LabelString);


  LabelString = XmStringCreate ("y value", XmFONTLIST_DEFAULT_TAG);

  n=0;
  XtSetArg (args[n], XmNrightAttachment, XmATTACH_FORM); n++;
  XtSetArg (args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
  XtSetArg (args[n], XmNleftWidget, X_Scale); n++;
  XtSetArg (args[n], XmNorientation, XmHORIZONTAL); n++;
  XtSetArg (args[n], XmNtitleString,LabelString); n++;
  XtSetArg (args[n], XmNscaleMultiple,10); n++;
  XtSetArg (args[n], XmNshowValue,True); n++;
  XtSetArg (args[n], XmNminimum, -200); n++;
  XtSetArg (args[n], XmNmaximum, 200); n++;
  Y_Scale = XmCreateScale (MainForm2, "Y_Scale", args, n);
  XtManageChild (Y_Scale);

  XmStringFree (LabelString);

}

void
SendPanMsg (Widget w, XtPointer client_data, XtPointer call_data)
{

  Time time;
  XtPointer     msg, fulldata;
  Position xpos, ypos;
  int delta_x, delta_y;
  Arg args[10];
  int n;
  unsigned long size = 0;



  time = ((XButtonEvent *) ((XmPushButtonCallbackStruct *)call_data)->event)->time;

  target = WM_PAN;
  /* get x and y delta's from scale */

  XmScaleGetValue (X_Scale, &delta_x);
  XmScaleGetValue (Y_Scale, &delta_y);

  
  /* Send Pan message to mwm. */
   

  size  += sizeof(CARD32);  /* delta_x */
  size += sizeof(CARD32);  /* delta_y */
  size += sizeof(CARD8);  /* delta_y */

  
  send_size = size;

  msg = fulldata = (XtPointer) XtMalloc(sizeof(CARD8) * size);

  msg = PackCARD32(msg, delta_x);
  msg = PackCARD32(msg, delta_y);
  msg = PackCARD8(msg, True);



  n=0;
  XtSetArg (args[n], XmNx, &xpos); n++;
  XtSetArg (args[n], XmNy, &ypos); n++;
  XtGetValues (TestShell1, args, n);

  printf ("Previous x position is %d\n", xpos);
  printf ("Previous y position is %d\n\n\n", ypos);

  XmeNamedSink (DrawingArea, 
	        WM_S0,
		XmCOPY,
	       (XtPointer)fulldata, 
		time);



}





void
SendGotoMsg (Widget w, XtPointer client_data, XtPointer call_data)
{

  Time time;
  int           abs_x,abs_y;
  XtPointer     msg, fulldata;
  Position xpos,ypos;
  Arg args[10];
  int n;
  unsigned long size = 0;


  time = ((XButtonEvent *) ((XmPushButtonCallbackStruct *)call_data)->event)->time;

  target = WM_GOTO;
  

  /* get x and y delta's from scale */

  XmScaleGetValue (X_Scale, &abs_x);
  XmScaleGetValue (Y_Scale, &abs_y);
  /*
   * Send Goto message to mwm.
   */
  size += sizeof(CARD32);  /* X */
  size += sizeof(CARD32);  /* Y */

  send_size = size;

  msg = fulldata = (XtPointer) XtMalloc(sizeof (size));

  msg = PackCARD32(msg, abs_x);
  msg = PackCARD32(msg, abs_y);


  n=0;
  XtSetArg (args[n], XmNx, &xpos); n++;
  XtSetArg (args[n], XmNy, &ypos); n++;
  XtGetValues (TestShell1, args, n);

  printf ("Previous x position is %d\n", xpos);
  printf ("Previous y position is %d\n\n\n", ypos);

  XmeNamedSink (DrawingArea, 
	        WM_S0,
		XmCOPY,
	       (XtPointer)fulldata, 
		time);
}


void
DestinationProc (Widget w, XtPointer client_data, XtPointer call_data)
{

  Arg args[10];
  int n;

  XmDestinationCallbackStruct *dcs = (XmDestinationCallbackStruct *)call_data;
  /* FIRST - setup the parameters to pass. */
  XmTransferSetParameters(dcs->transfer_id,
                          dcs->location_data,   /* pointer to param data. */
                          8,
			  send_size,
                          dcs->selection);      /* type - don't care. */


  XmTransferValue(dcs->transfer_id,
                  target,
                  DoneProc,
                  dcs->location_data,   
                  dcs->time);
}

  




void
DoneProc (Widget w, XtPointer client_data, XtPointer call_data)
{

  Position xpos,ypos;
  Arg args[10];
  int n;


  printf("Convert request returned.\n\n");


  n=0;
  XtSetArg (args[n], XmNx, &xpos); n++;
  XtSetArg (args[n], XmNy, &ypos); n++;
  XtGetValues (TestShell1, args, n);

  printf ("New x position is %d\n", xpos);
  printf ("New y position is %d\n\n\n", ypos);
  
}


     



/* packing functions */

static XtPointer
PackCARD32 (XtPointer data, CARD32 val)
{
  CARD16 bottom = val & (0xFFFF);
  CARD16 top = val >> 16;

  data = PackCARD16(data, top);
  data = PackCARD16(data, bottom);
  return(data);
}


static XtPointer
PackCARD16 (XtPointer data, CARD16 val)
{
  CARD8 bottom = val & (0xFF);
  CARD8 top = val >> 8;

  data = PackCARD8(data, top);
  data = PackCARD8(data, bottom);
  return(data);
}


static XtPointer
PackCARD8 (XtPointer data, CARD8 val)
{
  CARD8 *ptr = (CARD8 *) data;

  *ptr = (CARD8) val;
  data = ((char*)data) + 1;
  return(data);
}
